#include "vfo.pio.h"
#include "pico/stdlib.h"
#include "pico/multicore.h"

uint32_t clk_khz = 125000;
uint32_t f=7074000;
  
void setup(void){
  set_sys_clock_khz(clk_khz,true);
}

void loop(){}

void setup1(void){
  uint32_t periods;
  uint32_t delta = 0;
  uint16_t t;

  PIO pio = pio0;
  gpio_init(0);
  gpio_set_dir(0, GPIO_OUT);
  pio_gpio_init(pio0, 15);         
  uint offset = pio_add_program(pio0, &vfo_program);         
  pio_sm_set_consecutive_pindirs(pio0, 0, 15, 1, true);          
  pio_sm_config c = vfo_program_get_default_config(offset); 
  sm_config_set_set_pins(&c, 15, 1);                  
  pio_sm_init(pio0, 0, offset, &c);       
  pio_sm_set_enabled(pio0, 0, true); 
  
  uint64_t ratio = (uint64_t)clk_khz *1000 *(1<<24)/(uint64_t)f;
  periods=(uint32_t)ratio-(10<<24); 
  
  while(1){
    t = (periods+delta) >> 24;  
    pio_sm_put_blocking(pio0, 0, t);
    delta += periods-(t << 24);      
  }
}

void loop1(){} 
