//PicoVFO bis 15 MHz
#include "vfo2.pio.h"
#include "pico/stdlib.h"
#include "pico/multicore.h"

uint32_t clk_khz = 180000;
volatile uint32_t f=7074000;
volatile uint32_t periods;
  
void setup(void){
  set_sys_clock_khz(clk_khz,true);
  Serial.begin(9600);
}

void set_freq(void){
  uint64_t ratio = (uint64_t)clk_khz*1000LL *(1<<24)/(uint64_t)f;
  periods=(uint32_t)(ratio/1-(10<<24)); 
}

void flush_input(void)
{
  while (Serial.available() > 0)
  Serial.read();
}

void loop(){
  if (Serial.available()) {
    int ch = Serial.read();
    f = Serial.parseInt();
    Serial.read();
    if((ch == 102)&& (f>100000)){  
      {set_freq();}
    }
  }
}

void setup1(void){
  uint16_t t;
  uint32_t delta;
  
  PIO pio = pio0;
  gpio_init(0);
  gpio_set_dir(0, GPIO_OUT);
  pio_gpio_init(pio0, 15);         
  uint offset = pio_add_program(pio0, &vfo_program);         
  pio_sm_set_consecutive_pindirs(pio0, 0, 15, 1, true);          
  pio_sm_config c = vfo_program_get_default_config(offset); 
  sm_config_set_set_pins(&c, 15, 1);                  
  pio_sm_init(pio0, 0, offset, &c);       
  pio_sm_set_enabled(pio0, 0, true); 
  set_freq();
  //periods=10<<24;
  for(;;){
    t = (periods+delta) >> 24;  
    pio_sm_put_blocking(pio0, 0, t);
    delta += periods-(t << 24);      
  }
}

void loop1(){} 
